#
# in the terminal
#   'ipcs' to see shared mem
#   'ipcrm -m ID to remove' to remove a dead shared mem
#   'pip3 install sysv_ipc' to instal sysv_ipc
#

import sys
import sysv_ipc
import datetime
import os

IS_PY3 = (sys.version_info[0] == 3)
to_chr = lambda c: chr(c) if IS_PY3 else c  # noqa E731  (silence flake8)
to_ord = lambda c: ord(c) if IS_PY3 else c  # noqa E731  (silence flake8)

memory1 = 0
key = 0

def pyFcn_with_param(StrBuff):
    # StrBuff.replace('*', '-') 	# use a loop to do a "fair" comparison with pyFcn_no_param()
    l=list(StrBuff)
    for i in range(0,len(StrBuff)):  
        l[i] = 'x'
    return ("Hi from Python no shm\n"+str(datetime.datetime.now())+"\n"+"".join(l))

def pyFcn_with_param2(Buff):
    return ("my pid is"+str(os.getpid())+"\nHi from Python no shm\n"+str(datetime.datetime.now())+"\n")

def SetShmKey(shmKey):
    global key
    if (key ==0):
        key = shmKey
        msg = ("key is set to '"+str(key)+"'")
    else:
        msg= ("key is alread set to '"+str(key)+"'")
    return msg

def pyFcn_no_param():
    import sysv_ipc
    global memory1
    global key

    if (key==0):                    # safe gard is key is not set
        key = 0x0001e240            # default, 0x0001e240 = 123456 dec
    if (memory1 == 0):               # safe gard is memory is not set
        memory1 = sysv_ipc.SharedMemory(key)
    memory_value = memory1.read()
    #ba = bytearray(memory) # ba is a COPY of the memory
    #ba = ba.replace(b'*', b'-')
    mv = memoryview(memory1) # mv modify the memory
    x = to_ord('x')
    for i in range(0,len(mv)):  #please vectorise me
        mv[i] = x
    memory1.write("Hi from Python\n"+str(datetime.datetime.now())+"\n")

def detach_shm():
    memory1.detach()
    return str(os.getpid())
